/******************************************************************************
                Constant Definitions
*******************************************************************************/

#define IPROP_CTLNAME        0
#define IPROP_LEFT           1
#define IPROP_TOP            2
#define IPROP_WIDTH          3
#define IPROP_HEIGHT         4
#define IPROP_VISIBLE        5
#define IPROP_HWND           6

#define IPROP_WORD_WRAP      7
#define IPROP_VSCROLL        8
#define IPROP_HSCROLL        9
#define IPROP_PRINT_VIEW    10
#define IPROP_SHOW_STATUS   11
#define IPROP_SHOW_RULER    12
#define IPROP_BORDER_MARGIN 13
#define IPROP_OUTPUT_RTF    14
#define IPROP_READ_ONLY     15
#define IPROP_PAGE_MODE     16
#define IPROP_SHOW_TOOLBAR  17

#define IPROP_DATA                18
#define IPROP_REPAINT             19
#define IPROP_SET_CHAR_STYLE      20
#define IPROP_RESET_CHAR_STYLE    21
#define IPROP_PARA_RESET          22
#define IPROP_PARA_STYLE          23
#define IPROP_PARA_INDENT_LEFT    24
#define IPROP_PARA_INDENT_RIGHT   25
#define IPROP_PARA_INDENT_HANGING 26

#define IPROP_SAVE_FORMAT         27
#define IPROP_COMMAND             28

#define IPROP_READ_FILE           29
#define IPROP_SAVE_FILE           30

#define FIRST_PROP_DESIGN   IPROP_WORD_WRAP
#define LAST_PROP_DESIGN    IPROP_SHOW_TOOLBAR
#define FIRST_PROP_RUNTIME  IPROP_DATA

#define IEVENT_CLICK     0
#define IEVENT_DBLCLICK  1
#define IEVENT_GOTFOCUS  2
#define IEVENT_LOSTFOCUS 3
#define IEVENT_HYPERTEXT 4
#define IEVENT_KEYDOWN   5
#define IEVENT_KEYUP     6
#define IEVENT_KEYPRESS  7

#define IDR_TOOLBAR_UP   100
#define IDR_TOOLBAR_DWN  101
#define IDR_TOOLBAR_MONO 103
#define IDR_TOOLBAR_EGA  106
